class GameScreen extends Screen{
  
  Level[] levels;
  PImage charFrame;
  PImage bg, platform, crossHair, player;
  boolean enemyFired = false, playerFired = false;
  int levelIndex;
  int startTime = 0;
  boolean weaponReady = false;
  char fireKey;
  final int countDown = 1000;
  final int entityHeight = 300 - 64;
  float targetX, targetY, targetRadius;
  float breathHeight = 0;
  
  public GameScreen(){
    super(); 
    
    charFrame = loadImage("charframe.png");
    bg = loadImage("bg.png");
    platform = loadImage("platform.png");
    crossHair = loadImage("crosshair.png");
    player = loadImage("chars/player.png");
    
    levels = new Level[8];
    levels[0] = new Level("Karatakatana", "kara", "Watashi wa, toirettopépá\no taberu", 12);
    levels[1] = new Level("Double-Oh-Pi", "00pi", "I kill people for a living.", 10);
    levels[2] = new Level("El Pene Grande", "penis", "Hairy balls of steel.", 8);
    levels[3] = new Level("The 40m", "turkey", "Gobble gobble. Gobble.\nGobble. GOBBLE.", 6.5);
    levels[4] = new Level("CNIAngel", "cni", "I watch dogs.", 5.5);
    levels[5] = new Level("Devil", "devil", "See you on the other side.", 4.5);
    levels[6] = new Level("Cthulu", "cthulu", "BLAAAARGH!", 3.85f);
    levels[7] = new Level("God", "fsm", "Feel the wrath of my\nnoodly appendage!", 3);
    
    enemyFired = false;
    playerFired = false;
    levelIndex = 0;
    startTime = millis() + countDown;
    weaponReady = false;
    fireKey = randomLetter();
    targetX = random(-100, 100);
    targetY = random(-60, 60);
    targetRadius = levels[levelIndex].difficulty*7.5;
    
    
  }
  
  public void progress(){
    if(levelIndex < levels.length-1){
      levelIndex ++;
      weaponReady = false;
      playerFired = false;
      enemyFired = false;
      startTime = millis() + countDown;
      fireKey = randomLetter();
      targetX = random(-150, 150);
    targetY = random(-40, 40);
      targetRadius = levels[levelIndex].difficulty*7.5;
    }else{
      screen = new MenuScreen();
    }
  }
  
  @Override public void update(){
    breathHeight = sin(frameCount/15f)*((15-levels[levelIndex].difficulty)*8);
    if(keyPressed && !keyPressedPreviously){
      if(key == '#') progress();
      else if(key == '\'') startTime = millis();
      else if(!(key+"").toLowerCase().equals(fireKey + "") && !playerFired){
        enemyFired = true;
        startTime -= levels[levelIndex].difficulty*500;
        if(sound) shot.trigger();
      }
    }
    noCursor();
    if(playerFired){
      if(millis() - startTime > 1000){
        progress();
      }
      return;
    }
    if(millis() - startTime > levels[levelIndex].difficulty*500){
      if(!enemyFired){
        if(sound) shot.trigger();
      }
      enemyFired = true;
      fireKey = randomLetter();
      if(millis() - startTime > (levels[levelIndex].difficulty + 3)*500){
        MenuScreen sc = new MenuScreen();
        sc.fsm = levels[levelIndex].icon;
        screen = sc;
      }
      return;
    }
    
    if(mousePressed){
      weaponReady = true;
    }
    if(weaponReady){
      if(keyPressed & (key+"").toLowerCase().equals(fireKey+"") && key != CODED && !keyPressedPreviously){
        if(!playerFired && !enemyFired){
          if(sound) shot.trigger();
          if(dist(width/2 + targetX, height*2/5 + targetY, mouseX, mouseY) < targetRadius){
            playerFired = true;
            startTime = millis();
          }else{
            enemyFired = true;
          }
        }
        
      }
    }
  }
  
  @Override public void render(){
    
    //image(bg, 0, 0, width, height);
    image(platform,0,0,width,height);
    image(charFrame, 0, 0, 128+20, 128+20);
    image(levels[levelIndex].icon, 10, 10, 128, 128);
    /*
    fill(0);
    textAlign(RIGHT);
    textSize(32);
    text(millis() + " : " + startTime, width-15, 50);
    */
    fill(orange);
    textSize(50);
    textAlign(LEFT);
    text(levels[levelIndex].enemyName, 170, 40);
    fill(yellow);
    text(levels[levelIndex].enemyName, 168, 39);
    textSize(24);
    fill(orange);
    text(levels[levelIndex].blurb, 171, 81);
    fill(yellow);
    text(levels[levelIndex].blurb, 170, 80);
    
    if(!enemyFired && !playerFired){
      copy(levels[levelIndex].sprite, 16*((frameCount/16)%2), 0, 16, 16, width*3/4, entityHeight, 64, 64);
    }else if(!playerFired){
      copy(levels[levelIndex].sprite, 16*((frameCount/16)%2), 0, 16, 16, width*3/4, entityHeight, -64, 64);
      copy(player, 0, 0, 16, 16, width/4 - 64, entityHeight, 64, 64);
    }
    
    if(!playerFired && !enemyFired){
      copy(player, 16*((frameCount/16)%2), 0, 16, 16, width/4 - 64, entityHeight, 64, 64);
    }else if(!enemyFired){
      copy(player, 16*((frameCount/16)%2), 0, 16, 16, width/4 + 64, entityHeight, -64, 64);
      copy(levels[levelIndex].sprite, 0, 0, 16, 16, width*3/4, entityHeight, 64, 64);
    }
    
    if(millis() - startTime > countDown){
      if(!playerFired && !enemyFired){
        if(weaponReady){
          textSize(64);
          
          fill(yellow);
          stroke(0);
          ellipse(width/2 + targetX, height*2/5 + targetY, targetRadius*2, targetRadius*2);
          fill(orange);
          textSize(targetRadius);
          textAlign(CENTER);
          text((""+fireKey).toUpperCase(), width/2 + targetX, height*2/5 + targetY + targetRadius/3);
          ;
          
          String s = "Aim at the Target\nAnd Press '" + (fireKey+"").toUpperCase() + "' to Fire!";
          textAlign(CENTER);
          textSize(42);
          fill(yellow);
          text(s, width/2+2, height - 69);
          fill(orange);
          text(s, width/2, height - 70);
        }else{
          textSize(72);
          textAlign(CENTER);
          String s = "Click to Load!";
          fill(orange);
          text(s, width/2 + 2, height/2 + 1);
          fill(yellow);
          text(s, width/2, height/2);
        }
      }
      }else if(!playerFired && !enemyFired){
        int num = startTime - millis();
        
        int millisGone = millis() - (startTime-countDown);
        int millisLeft = 2*countDown - millisGone;
        int c = millisLeft/(countDown*2/3) + 1;
        textSize(84);
        fill(orange);
        text(c, width/2+2, height/2+1);
        fill(yellow);
        text(c, width/2, height/2);
        return;
      }
    imageMode(CENTER);
    image(crossHair, mouseX, mouseY + breathHeight);
    imageMode(CORNER);
  }
  
  public char randomLetter(){
    char[] chars = {'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z'};
    return chars[int(random(chars.length))];
  }
}

class Level{
  PImage icon;
  PImage sprite;
  String enemyName, blurb;
  float difficulty;
  
  public Level(String enemyName, String fileName, String blurb, float difficulty){
    this.enemyName = enemyName;
    this.difficulty = difficulty;
    this.blurb = blurb;
    this.icon = loadImage("chars/" + fileName.toLowerCase() + "/icon.png");
    this.sprite = loadImage("chars/" + fileName.toLowerCase() + "/sprite.png");
  }
}
