import java.awt.Rectangle;
import java.awt.Desktop;
import java.net.URI;
import java.net.URL;

class MenuScreen extends Screen{
  Button[] buttons;
  PImage bg, title;
  PImage fsm;
  
  public MenuScreen(){
     super();
     
     bg = loadImage("bg.png");
     title = loadImage("title.png");
     fsm = loadImage("chars/fsm/icon.png");
     buttons = new Button[4];
     buttons[0] = new Button(width/4, height*5/11, 72, "PLAY");
     buttons[1] = new Button(width/4, height*7/11, 72, "QUIT");
     buttons[2] = new Button(width-80, 20, 18, "Sound");
     buttons[3] = new Button(width/4, height*9/11, 72, "DONATE");
  }
  
  @Override public void update(){
      for(int i = 0; i < buttons.length; i ++){
        buttons[i].update();
      }
      
      if(buttons[0].clicked){
        if(sound) shot.trigger();
        screen = new GameScreen();
      }
      if(buttons[1].clicked){
        if(sound) shot.trigger();
        exit();
      }
      buttons[2].text = "Sound: " + (sound? "On":"Off");
      if(buttons[2].clicked){
        sound = !sound;
        if(sound){
          theme.loop();
        }else{
          theme.pause();
        }
        if(sound) shot.trigger();
      }
      if(buttons[3].clicked){
        if(sound) shot.trigger();
        try{
          Desktop.getDesktop().browse(new URL("http://www.bothar.ie/").toURI());
        }catch(Exception e){
          println("could not open bothar.ie in default browser.");
        }
      }
  }
  
  @Override public void render(){
      //background(0);
      background(255, 255, 136);
      image(fsm, width - 300, height - 300, 256, 256);
      image(title, width/2 - title.width/2, 10);
      fill(yellow);
      String s = "Shoot first; Ask\nQuestions Later.";
      textAlign(CENTER);
      textSize(18);
      text(s, width/2+2, height/3+1);
      fill(orange);
      text(s, width/2, height/3);
      for(int i = 0; i < buttons.length; i ++){
        buttons[i].render();
      }
  }
}

class Button{
  Rectangle bounds;
  String text;
  int size = 12;
  boolean pressed = false, clicked = false, hovered = false;
  
  public Button(float x, float y, int size, String text){
    textSize(size);
    int w = int(textWidth(text));
    this.bounds = new Rectangle(int(x-w/2), int(y), w, size);
    this.size = size;
    this.text = text;
  }
  
  public void update(){
    pressed = false;
    clicked = false;
    hovered = false;
    if(bounds.contains(mouseX, mouseY)){
      hovered = true;
      cursor(HAND);
      if(mousePressed){
        pressed = true;
      }else if(mousePressedPreviously){
        clicked = true;
      }
    }
  }
  
  public void render(){
    textAlign(CENTER);
    textSize(size);
    int y = bounds.y + bounds.height*4/5;
    int x = bounds.x + bounds.width/2;
    fill(orange);
    text(text, x+3, y+2);
    fill(yellow);
    if(hovered){
      fill(0, 0, 0);
    }
    text(text, x, y);
    
    textSize(8);
    textAlign(RIGHT);
    fill(0);
    text("Made for the Charity Game Jam 2013: http://charitygamejam.com\nGunshot sound from: http://soundbible.com/1960-Shotgun-Old-School.html", width-5, height-15);
  }
}
